SystemOrganization addCategory: #'GBT-DSL_EFA'!

Object subclass: #EFA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

EFA subclass: #Auswertungen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Auswertungen methodsFor: 'as yet unclassified' stamp: 'hk 11/3/2017 17:53'!
contexts

^'plain Auswertungen of FahrtContext{
	displayAs	: Auswertungen
	icon	: #beitragsMgmt16
	uiSpec	: #GbtListAndItemUI
	poolThings	: 
	templates	: FahrtContext
	loadPolicy	: #autoload
	subcontexts	: FahrtContext
	legalText	: 
	behaviors	: 
	onCreate	: 
	}'! !

!EFA class methodsFor: 'example' stamp: 'hk 11/9/2017 17:41'!
exampleRun
	GbtServer clearStore; initialize. 
	self installUsers.
	Boote new ensureCompilation; storeBoote.
	Personen new ensureCompilation; storePersonen.
	Fahrtenbuch new ensureCompilation; storeTestFahrten.		"needs Boote"
	Beitragsmanagement new ensureCompilation.
	Beitragstabellen new ensureCompilation; storeBeitragstabellen.
	Beitragsabrechnung new ensureCompilation.
	Rechnungen new ensureCompilation.
	OPListen new ensureCompilation.
	Statistics new ensureCompilation.
	(self new 
		ensureCompilation ;
		loginContext) ui 
			title: #Login; 
			open! !

!EFA class methodsFor: 'example' stamp: 'hk 8/16/2017 17:15'!
installUsers
		#(Tom Lisa) do: [:u| GbtServer default addUser: u withRole: GbtRole forExecute ].
		#(Tony Robert) do: [:u| GbtServer default addUser: u withRole: GbtRole forWrite ].
		#(Bob) do: [:u| GbtServer default addUser: u withRole: GbtRole forRead ]! !

!EFA methodsFor: 'functions' stamp: 'hk 11/7/2017 20:20'!
behaviors
	^''! !

!EFA methodsFor: 'contexts' stamp: 'hk 11/7/2017 20:21'!
contexts
	^'
	plain EFALogin {
	displayAs	: EFA
	icon	: efa
	uiSpec	: GbtLoginUI
	subcontexts	: EFA 
	legalText	: GloConn International © 2016
	}
plain EFA {
	displayAs	: EFA
	icon	: efa
	uiSpec	: GbtMainUI
	windowSize	: 1200@800
	subcontexts	: FahrtenBuchContext BooteContext PersonenContext BeitragsmanagementContext StatisticsContext 
	legalText	: GloConn International © 2016
	}
'! !

!EFA methodsFor: 'functions' stamp: 'hk 11/7/2017 20:20'!
directives
	^''! !

!EFA methodsFor: 'compile' stamp: 'hk 11/8/2017 15:22'!
ensureCompilation
	"sort of incremental ..."
	GbtCompiler new parse: self things onError: [ :msg :pos | self error: msg, ' at: ', pos printString ]. 
	GbtCompiler new parse: self directives onError: [ :msg :pos | self error: msg, ' at: ', pos printString ].
	GbtCompiler new parse: self contexts onError: [ :msg :pos | self error: msg, ' at: ', pos printString].
	GbtCompiler new parse: self behaviors  onError: [ :msg :pos | self error: msg, ' at: ', pos printString]. ! !

!EFA methodsFor: 'contexts' stamp: 'hk 11/7/2017 20:19'!
loginContext 
	^GbtActiveContext definedAs: 'EFALogin' 
! !

!EFA methodsFor: 'things' stamp: 'hk 11/7/2017 20:20'!
things
	^''! !

EFA subclass: #Fahrtenbuch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Fahrtenbuch class methodsFor: 'examples' stamp: 'hk 11/8/2017 15:25'!
exampleRun
	GbtServer clearStore; initialize. 
	Boote new ensureCompilation; storeBoote.
	(self new 
		ensureCompilation ; 
		storeTestFahrten ; 
		fahrtenBuchContext) ui 
			title: #Fahrtenbuch; 
			open! !

!Fahrtenbuch methodsFor: 'functions' stamp: 'hk 11/24/2017 15:38'!
behaviors
^'
	behavior chooseBoat  { 
		chooseBoat 		:  askContext(BooteContext)
	}
	behavior choosePerson  { 
		person 			:  askContext(PersonenContext)
		choosePerson 	:  transform( RudererDirective person)
	}
'
! !

!Fahrtenbuch methodsFor: 'contexts' stamp: 'hk 10/17/2017 14:24'!
contexts
	^ '	plain FahrtContext {
		subcontexts 	: 	BuddyWallet 
		uiSpec 		: 	GbtItemUI 
		icon 			: 	rowingTeam
		displayAs 	: 	Fahrt
		behaviors 	:  chooseBoat choosePerson
		onExpand 		:  Boot chooseBoat
		onExpand 		: 	Steuermann choosePerson   
		onExpand 		: 	Mannschaft choosePerson
		legalText 	: 	GloConn International © 2016
		}
	primeList FahrtenBuchContext of Fahrt {  
	 	displayAs 	: 	FahrtenBuch
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	rowingTeam
		loadPolicy 	: 	autoload 

		listColumns 	: 	(Bootsname Boot) (RudererName Steuermann) Abfahrt 
		listPrefix 	: 	Fahrt 
		subcontext 	: 	FahrtContext 
		}
	'
	
"		{#filterBy: . #(Bootsname RudererName) } .		"! !

!Fahrtenbuch methodsFor: 'functions' stamp: 'hk 11/4/2017 21:41'!
directives
	^'
	directive RudererDirective  {
		tag RudererName : Nachname 
		tag RudererVorname : Vorname 
		tag SportlerId : bizId 
		FremdVerein  
		}	
	'
! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:36'!
fahrt
	^GbtSmartNode copy: 'Fahrt'! !

!Fahrtenbuch methodsFor: 'contexts' stamp: 'hk 10/17/2017 12:58'!
fahrtenBuchContext 
	^GbtActiveContext definedAs: 'FahrtenBuchContext' ! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:03'!
nextBizID
	^GbtServer default nextIdOfContextNoPolicy: #FahrtenBuchContext! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:36'!
ruderer
	^GbtSmartNode copy: 'Ruderer'! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:31'!
storeTestFahrten
	GbtServer default contextNoPolicyOf: #FahrtenBuchContext prefix: #Fahrt.
	self testFahrt1 storeSubtree.
	self testFahrt2 storeSubtree.
	self testFahrt3 storeSubtree.
	self testFahrt4 storeSubtree.
	self testFahrt5 storeSubtree.
	self testFahrt6 storeSubtree! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:04'!
testFahrt1
	^self fahrt 
		bizId: self nextBizID;
		Bootsname: #Alster;
		Steuermann: self testRuderer1;
		Kilometer: 20;
		yourself
! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:05'!
testFahrt2
	^self fahrt 
		bizId: self nextBizID;
		Bootsname: #Alster;
		Steuermann: self testRuderer2;
		Kilometer: 28;
		yourself
! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:05'!
testFahrt3
	^self fahrt 
		bizId: self nextBizID;
		Bootsname: #Alster;
		Steuermann: self testRuderer3;
		Kilometer: 30;
		yourself
! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:06'!
testFahrt4
	| aFahrt |
	aFahrt := self fahrt 
		bizId: self nextBizID;
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 99;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer1 .
	^aFahrt

! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:06'!
testFahrt5
	| aFahrt |
	aFahrt := self fahrt 
		bizId: self nextBizID;
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 77;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer2.
	^aFahrt
! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:06'!
testFahrt6
	| aFahrt |
	aFahrt := self fahrt 
		bizId: self nextBizID;
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 66;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer3.
	^aFahrt 

! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 11/9/2017 17:52'!
testRuderer1
	^self ruderer
		RudererName: #Schmidt1; 
		RudererVorname: #Henning;
		yourself! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:07'!
testRuderer2
	^self ruderer
		RudererName: #Schmidt2;
		RudererVorname: #Henning;
		yourself! !

!Fahrtenbuch methodsFor: 'test data' stamp: 'hk 10/17/2017 14:07'!
testRuderer3
	^self ruderer
		RudererName: #Schmidt3;
		RudererVorname: #Henning;
		yourself! !

!Fahrtenbuch methodsFor: 'things' stamp: 'hk 12/1/2017 09:11'!
things
	^ '	thing Besatzung 
		summary 				:  system template
		{ 
		*node Steuermann 	:  Ruderer
		*list Mannschaft 	:  Ruderer
		}
	thing Fahrt
		summary 				:  ''#bizId : #Besatzung:RudererName #Mannschaft ab: #Abfahrt an: #Ankunft''
		bizIdPolicy 			: FahrtNoPolicy
		{ 
		*date Datum  		: date(today)
		*node Boot 			: Boot 
		*node Besatzung 	: Besatzung 
		*date Abfahrt  		: 1 July 2016
		*date Ankunft  		: 2 July 2016
		*val Ziel 	 		: Fluss | Mündung {ui: GbtChoiceWidget}
		*no Kilometer		: 0
		text Bemerkung 		:
		val FahrtArt 		: Normale Fahrt | Trainingsfahrt | Wanderfahrt {ui: GbtChoiceWidget}
		}				
	thing Ruderer
		summary 				: ''#RudererName , #RudererVorname''
		purposes 				: Steuermann Ruderer
		{  
		*val RudererName	:  
		*val RudererVorname:  
		*val SportlerId 	:  
		val FremdVerein 	:  
		}
'! !

EFA subclass: #Finanzen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Finanzen subclass: #Beitragsabrechnung
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragsabrechnung commentStamp: 'hk 11/7/2017 11:54' prior: 0!
Implementation Points

does not work without Beitragstabellen!

!Beitragsabrechnung class methodsFor: 'example' stamp: 'hk 11/8/2017 15:14'!
exampleRun
	GbtServer clearStore; initialize. 
	Beitragstabellen new ensureCompilation.
	(self new 
		ensureCompilation ;
		beitragsabrechnungenContext) ui 
			title: #Beitragsabrechnungen; 
			open! !

!Beitragsabrechnung methodsFor: 'functions' stamp: 'hk 11/24/2017 15:39'!
behaviors
	^ '
behavior chooseB { 
	chooseB :  askContext(BeitragstabellenContext)
	}				
behavior Abrechnung { 
	personen 			:  PersonenContext:list 
	tabelle			:  contextThing:Beitragstabelle
	beitragsliste 	:  transform(BeitragDir personen  tabelle	)
	beitraege			:  freeze (beitragsliste)		
	Abrechnung 		:  contextThing:Beitragsliste := nodeList(beitraege)
	}
'! !

!Beitragsabrechnung methodsFor: 'contexts' stamp: 'hk 11/6/2017 18:43'!
beitragsabrechnungenContext 
	^GbtActiveContext definedAs: 'BeitragsabrechungenContext' ! !

!Beitragsabrechnung methodsFor: 'contexts' stamp: 'hk 11/23/2017 11:09'!
contexts

^'
plain BeitragContext {
	displayAs	: Beitrag
	icon	: beitragsMgmt16
	uiSpec	: GbtItemUI
	}
plain BeitragsabrechnungContext {
	displayAs	: Beitragsabrechnung
	icon	: beitragsMgmt16
	uiSpec	: GbtItemWithTabsUI
	poolThings 	:  BeitragDir
	subcontexts	: BeitragslisteContext 
	menu	: BeitraegsMenu Abrechnung Einbuchen
	onExpand 		:  Beitragstabelle chooseB
	behaviors	: Abrechnung chooseB
	}
primeList BeitragsabrechungenContext  of Beitragsabrechnung {
	displayAs	: Beitragsabrechnungen
	icon	: beitragsMgmt16
	uiSpec	: GbtListAndItemUI
	loadPolicy	: autoload
	listColumns	: (BeitragssummeGesamt Summe)(AnzahlMitglieder Mitglieder)(AnzahlVollzahler Vollzahler)(AnzahlRabattierteMitglieder rabattiert)
	listPrefix	: Abrechnung
	subcontext	: BeitragsabrechnungContext
	elderSlot 	: Beitragsabrechnungen
	}
uList BeitragslisteContext  of Beitrag {
	displayAs	: Beitragsliste
	icon	: beitragsMgmt16
	uiSpec	: GbtListAndItemUI
	listColumns	: Nachname Vorname Betrag 
	subcontext	: BeitragContext
	elderSlot	: Beitragsliste
	}
'! !

!Beitragsabrechnung methodsFor: 'functions' stamp: 'hk 11/16/2017 17:14'!
directives
	^ 'directive BeitragDir {
	Berechnungsdatum
	Nachname
	Vorname
	tag Mitgliedsnummer : bizId
	FamilienOberhaupt
	Mitgliedstatus
	Beitragstatus
	Familienname
	FamilienNummer
	FamilienmitgliedNr
	aktiv
	passiv
	Familienrabatt
	Mindestbeitrag
	normalBeitrag
	ermBeitrag
	beitrag
	Betrag
	Währung
	tag vz : vollzahler
	tag rz : rabattiert
	tag az : anzahl
	Rechnungserzeugung
	Fälligkeit
	}
'! !

!Beitragsabrechnung methodsFor: 'things' stamp: 'hk 12/1/2017 09:28'!
things
	^ '
thing Abrechnungszeitraum
	summary	: system template
	{
	*date Von	: 3 November 2017
	*date bis	: 3 November 2017
	}
thing Beitrag
	summary	: #Nachname #Vorname EUR #Betrag
	{
	*date Berechnungsdatum	: 3 November 2017
	*val Nachname	: 
	*val Vorname	: 
	*val Mitgliedsnummer	: 
	*bool FamilienOberhaupt	: false 
	*val Mitgliedstatus	: aktiv | passiv {ui: GbtChoiceWidget}
	*val Beitragstatus	: Erwachsener | Nichtverdiener14plus | Kind14minus {ui: GbtChoiceWidget}
	*val Familienname	: 
	*no FamilienmitgliedNr	: 1
	*no normalBeitrag	: 0
	*no Familienrabatt	: 0
	*no Mindestbeitrag	: 0
	*no ermBeitrag	: 0
	*no beitrag	: 0
	*no Betrag	: 0
	*val Währung	: EUR
	*val vz	: 
	*val rz	: 
	*no az	: 1
	*bool Rechnungserzeugung	: false | true {ui: GbtChoiceWidget}
	*date Fälligkeit	: 3 November 2017
	}
thing Beitragsabrechnung
	summary	: #Abrechnungsname #BeitragssummeGesamt
	bizIdPolicy	: BeitragsAbrechnungsNoPolicy
	{
	*val Abrechnungsgenauigkeit	: Tag | Monat | Halbjahr | Jahr {ui: GbtChoiceWidget}
	*val Abrechnungsname	: 
	*node Abrechnungszeitraum	: Abrechnungszeitraum
	node Beitragstabelle	: HKBeitragstabelle
	*val Abrechner	: 
	*list Beitragsliste	: Beitrag 
	*no BeitragssummeGesamt	: sumTag (beitrag)
	*no AnzahlVollzahler	: sumTag (vz)
	*no AnzahlRabattierteMitglieder	: sumTag (rz)
	*no AnzahlMitglieder	: sumTag (az)
	}
 '! !

Finanzen subclass: #Beitragsmanagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragsmanagement commentStamp: 'hk 11/9/2017 12:07' prior: 0!
Implementation Points

Construction problem: 

Beitragsmanagement has 4 Ulists:
- Beitragstabellen 
- Beitragsabrechnung
- Rechnungen
- opListen 
However, the subcontexts for these Ulists in Beitragsmanagement are primeLists.

As such, the list elements are never stored in the Ulists .....!

!Beitragsmanagement class methodsFor: 'examples' stamp: 'hk 11/8/2017 15:15'!
exampleRun
	GbtServer clearStore; initialize. 
	Beitragstabellen new ensureCompilation; storeBeitragstabellen.
	Beitragsabrechnung new ensureCompilation.
	Rechnungen new ensureCompilation.
	OPListen new ensureCompilation.
	(self new 
		ensureCompilation ;
		beitragsmanagementContext) ui 
			title: #Beitragsmanagement; 
			open! !

!Beitragsmanagement methodsFor: 'functions' stamp: 'hk 11/6/2017 18:39'!
behaviors
^''! !

!Beitragsmanagement methodsFor: 'contexts' stamp: 'hk 11/7/2017 12:02'!
beitragsmanagementContext 
	^GbtActiveContext definedAs: 'BeitragsmanagementContext' ! !

!Beitragsmanagement methodsFor: 'contexts' stamp: 'hk 11/8/2017 16:15'!
contexts
^'
plain BeitragsmanagementContext  on Beitragsmanagement {
	displayAs	: Beitragsmanagment
	icon	: beitragsMgmt16
	uiSpec	: GbtItemWithTabsUI
	subcontexts	: BeitragstabellenContext BeitragsabrechungenContext RechnungenContext opListenContext
	menu	: Beitragsmanagement DoSomething1 DoSomething2
	}'! !

!Beitragsmanagement methodsFor: 'functions' stamp: 'hk 11/6/2017 18:39'!
directives
^''! !

!Beitragsmanagement methodsFor: 'things' stamp: 'hk 11/8/2017 16:15'!
things
	^ '	
thing Beitragsmanagement
	{
	*val AktuellerAbrechnungszeitraum	: 
	*no OffeneBeitraege	: 0
	*list Beitragstabellen	: HKBeitragstabelle
	*list Beitragsabrechnungen	: Beitragsabrechnung
	*list Rechnungen	: Rechnung
	*list opListen	: opListe
	}
 '! !

Finanzen subclass: #Beitragstabellen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragstabellen class methodsFor: 'example' stamp: 'hk 11/8/2017 15:13'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		storeBeitragstabellen;
		beitragstabellenContext) ui 
			title: #Beitragstabellen; 
			open! !

!Beitragstabellen methodsFor: 'functions' stamp: 'hk 11/6/2017 18:18'!
behaviors
	^ ''! !

!Beitragstabellen methodsFor: 'test data' stamp: 'hk 11/8/2017 15:06'!
beitragsTabelle
	^GbtSmartNode copy: 'HKBeitragstabelle'! !

!Beitragstabellen methodsFor: 'test data' stamp: 'hk 11/8/2017 15:08'!
beitragsTabelle2016 
	^self beitragsTabelle 
		TabellenName: #Jahr_2016 ;
		GueltigkeitVon: '01.01.2016' ;
		GueltigkeitBis: '12.31.2016';
		Mindestbeitrag: 70.00 ;		
		Familienrabatt: 0.5;		
		BeschlossenAm: '03.02.2016';	
		Abrechnungsmodus: #GanzjahresAbrechnung	;
		yourself
! !

!Beitragstabellen methodsFor: 'test data' stamp: 'hk 11/8/2017 15:08'!
beitragsTabelle2016HJ1 
	^self beitragsTabelle 
		TabellenName: #'1.HJ_2016' ;
		GueltigkeitVon: '01.01.2016' ;
		GueltigkeitBis: '06.30.2016';
		Mindestbeitrag: 70.00 ;		
		Familienrabatt: 0.5;		
		BeschlossenAm: '03.02.2016';		
		yourself! !

!Beitragstabellen methodsFor: 'test data' stamp: 'hk 11/8/2017 15:09'!
beitragsTabelle2016HJ2
	^self beitragsTabelle 
		TabellenName: #'2.HJ_2016' ;
		GueltigkeitVon: '07.01.2016' ;
		GueltigkeitBis: '12.31.2016';
		Mindestbeitrag: 80.00 ;		
		Familienrabatt: 0.4;		
		BeschlossenAm: '03.02.2016';		
		yourself! !

!Beitragstabellen methodsFor: 'contexts' stamp: 'hk 11/6/2017 18:34'!
beitragstabellenContext 
	^GbtActiveContext definedAs: 'BeitragstabellenContext' 
! !

!Beitragstabellen methodsFor: 'contexts' stamp: 'hk 11/8/2017 12:26'!
contexts
^'
plain BeitragstabelleContext {
	displayAs	: Beitragstabelle
	icon	: beitragsMgmt16
	uiSpec	: GbtItemUI
	}
primeList BeitragstabellenContext  of HKBeitragstabelle {
	displayAs	: Beitragstabellen
	icon	: bizoffer16
	uiSpec	: GbtListAndItemUI
	loadPolicy	: autoload
	listColumns	: (TabellenName Name)(GueltigkeitVon von)(GueltigkeitBis bis)
	listPrefix	: BT
	subcontext	: BeitragstabelleContext
	elderSlot 	: Beitragstabellen
	}
	'
! !

!Beitragstabellen methodsFor: 'functions' stamp: 'hk 11/6/2017 18:18'!
directives
	^ ''! !

!Beitragstabellen methodsFor: 'test data' stamp: 'hk 11/8/2017 15:04'!
storeBeitragstabellen
	self beitragsTabelle2016 storeSubtree.
	self beitragsTabelle2016HJ1 storeSubtree.
	self beitragsTabelle2016HJ2 storeSubtree! !

!Beitragstabellen methodsFor: 'things' stamp: 'hk 12/1/2017 09:29'!
things
	^ '
thing BasisBeitragAktiv
	summary	: system template
	{
	*no Erwachsener	: 230
	*no Nichtverdiener14plus	: 135
	*no Kind14minus	: 100
	}
thing BasisBeitragPassiv
	summary	: system template
	{
	*no Erwachsener	: 115
	*no Nichtverdiener14plus	: 115
	*no Kind14minus	: 115
	}
thing BeitragXLS
	summary	: system template
	{
	*node aktiv	: FBasisBeitragAktiv {tags: aktiv }
	*node passiv	: FBasisBeitragPassiv {tags: passiv }
	*val Währung	: EUR
	*no Mindestbeitrag	: 70.0
	*no Familienrabatt	: 0.5
	*ref normalBeitrag	: lookup (Mitgliedstatus Beitragstatus)
	*no ermBeitrag	:  if ( #FamilienmitgliedNr = 2 ; #normalBeitrag * #Familienrabatt ; #Mindestbeitrag )
	*no beitrag	:  if ( #FamilienOberhaupt ; #normalBeitrag ; #ermBeitrag )
	*no Betrag	:  max ( #beitrag ; #Mindestbeitrag  )
	*no vollzahler	:  if ( #Betrag = #normalBeitrag ; 1 ; 0 )
	*no rabattiert	:  if ( #Betrag = #normalBeitrag ; 0 ; 1 )
	*no anzahl	: 1
	}
thing HKBeitragstabelle
	summary	: #TabellenName : #GueltigkeitVon - #GueltigkeitBis 
	bizIdPolicy	: BeitragsTabelleNoPolicy
	{
	*val TabellenName	: 
	*date GueltigkeitVon	: 6 November 2017
	*date GueltigkeitBis	: 6 November 2017
	*val Abrechnungsmodus	: HalbjahresAbrechnung | GanzjahresAbrechnung {ui: GbtChoiceWidget}
	*node BeitragXLS	: FBeitragXLS
	*date BeschlossenAm	: 6 November 2017
	*val BeschlossenDurch	: Hauptversammlung | Sonderregelung {ui: GbtChoiceWidget}
	}
	'! !

Finanzen subclass: #OPListen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!OPListen class methodsFor: 'example' stamp: 'hk 11/8/2017 15:14'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		opListenContext) ui 
			title: #OP_Listen; 
			open! !

!OPListen methodsFor: 'functions' stamp: 'hk 11/6/2017 18:10'!
behaviors
	^''! !

!OPListen methodsFor: 'contexts' stamp: 'hk 11/8/2017 14:55'!
contexts
^'
plain opListeContext {
	displayAs	: OPListe
	icon	: beitragsMgmt16
	uiSpec	: GbtItemUI
	behaviors	: Mahnungen verschicken
	}
primeList opListenContext  of opListe {
	displayAs	: OPListen
	icon	: bizoffer16
	uiSpec	: GbtListAndItemUI
	loadPolicy	: autoload
	listColumns	: (bizId Rechnungsnummer)(Rechnungsbeitrag Beitrag)
	subcontext	: opListeContext
	elderSlot 	: opListen
	}
'! !

!OPListen methodsFor: 'functions' stamp: 'hk 11/6/2017 18:10'!
directives
	^''! !

!OPListen methodsFor: 'contexts' stamp: 'hk 11/6/2017 18:08'!
opListenContext 
	^GbtActiveContext definedAs: 'opListenContext' 
! !

!OPListen methodsFor: 'things' stamp: 'hk 12/1/2017 09:29'!
things
	^ '
thing opListe
	summary	: #bizId #Berechnungsdatum EUR #Beitragshöhe
	bizIdPolicy	: OPListeNoPolicy
	{
	*val Bezeichnung	: 
	*val Erstellung	: Rechnung  | Storno {ui: GbtChoiceWidget}
	*list OPListeAktuell	: Rechnung 
	*no OPSumme	: 0
	}
'! !

Finanzen subclass: #Rechnungen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Rechnungen class methodsFor: 'examples' stamp: 'hk 11/8/2017 15:14'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		rechnungenContext) ui 
			title: #Rechnungsn; 
			open! !

!Rechnungen methodsFor: 'functions' stamp: 'hk 11/24/2017 15:40'!
behaviors
^'behavior Rechnungslauf { 
		abrechnung 		: askContext(BeitragsabrechungenContext)
		liste 				: abrechnung:Beitragsliste:list
		oberhaeupter 	: filter(liste OberhauptConstraint)
		behPos				: RechnungContext:rgPositionen
		Rechnungslauf 	: applyOnList(behPos oberhaeupter liste)
	}
behavior neueRechnung { 
		abrechnung 		: askContext(BeitragsabrechungenContext)
		liste 				: abrechnung:Beitragsliste:list
		adressat 			: askUser (liste)		
		behPos				: RechnungContext:rgPositionen
		neueRechnung 			: apply(behPos adressat liste)
	}
behavior rgPositionen { 
		arg1 	 			:     	% Beitragsabrechnung eines Oberhaupts
		arg2 				:     % alle Beitragsabrechnungen
		neueRechnung 	: newContextThing
		RgMitAdressat	: neueRechnung:AdressatNummer := arg1:Mitgliedsnummer
		oberhauptPos		: transform ( DirRechnungsposition arg1)	
		rechnung 			: append(RgMitAdressat:Rechnungspositionen oberhauptPos)
		liste2 			: transform (DirRechnungBeitrag freeze(arg2)  RgMitAdressat)
		liste1 			: filter (liste2 FamilienConstraint)  % filter auf Adressat
		liste 				: transform ( DirRechnungsposition liste1)
		rgPositionen 	: append (rechnung:Rechnungspositionen liste)
	}
	'
! !

!Rechnungen methodsFor: 'contexts' stamp: 'hk 11/22/2017 14:40'!
contexts
	^ '	
plain RechnungContext  {
	displayAs		: Rechnung
	icon			: beitragsMgmt16
	uiSpec			: GbtItemUI
	poolThings 	: DirRechnungsposition DirRechnungBeitrag FamilienConstraint
	behaviors		: rgPositionen
	}
primeList RechnungenContext  of Rechnung {
	displayAs		: Rechnungen
	icon			: bizoffer16
	uiSpec			: GbtListAndItemUI
	loadPolicy	: autoload
	poolThings 	: OberhauptConstraint 
	listColumns	: (AdressatNummer Mitgliedsnummer)(Rechnungsbeitrag Beitrag)
	listPrefix	: Rng
	subcontext	: RechnungContext
	menu			: Rechnungslauf 
	menu			: neueRechnung
	behaviors		: Rechnungslauf neueRechnung
	elderSlot 	: Rechnungen
	}
 '
! !

!Rechnungen methodsFor: 'functions' stamp: 'hk 11/21/2017 16:56'!
directives
	^ '
directive DirRechnungBeitrag {
	Berechnungsdatum
	Nachname
	Vorname
	Mitgliedsnummer
	Familienname
	FamilienNummer
	FamilienmitgliedNr
	Betrag
	Währung
	AdressatNummer
	}
directive DirRechnungsadresse {
	tag AdressatName : Nachame
	tag AdressatVorname : Vorname
	StraßeUndNummer
	PLZUndWohnort
	}
directive DirRechnungsposition {
	Nachname
	Vorname
	Mitgliedsnummer
	tag AbrechnungVon : Berechnungsdatum
	AbrechnungBis
	Betrag
	Währung
	}
'! !

!Rechnungen methodsFor: 'contexts' stamp: 'hk 11/6/2017 18:03'!
rechnungenContext 
	^GbtActiveContext definedAs: 'RechnungenContext' 
! !

!Rechnungen methodsFor: 'things' stamp: 'hk 12/1/2017 09:30'!
things
	^ '
thing FamilienConstraint
	{
	*constraint mitglied	: #FamilienmitgliedNr > 1
	*constraint familie	: #FamilienNummer = #AdressatNummer
	}
thing OberhauptConstraint
	{
	*constraint mitglied	: #FamilienmitgliedNr = 1
	}
thing Rechnung
	summary							: #bizId #Berechnungsdatum EUR #Beitragshöhe
	bizIdPolicy						: RechnungNoPolicy
	{
	*val Rechnungstyp				: Rechnung | Storno {ui: GbtChoiceWidget}
	*date Rechnungsdatum			: 3 November 2017
	*val Rechnungskopf				: Absender aus Vereinsstammdaten
	*node Rechnungsadresse		: FRechnungsadresse
	*list Rechnungspositionen	: Rechnungsposition
	*no Rechnungsbeitrag			: sumTag (Betrag)
	bool Eingebucht					: false | true {ui: GbtChoiceWidget}
	date Buchungsdatum				: 3 November 2017
	date Fälligkeit					: 3 November 2017
	}
thing Rechnungsadresse
	summary					: system template
	{
	*val AdressatNummer	: bizId
	*val AdressatName		: 
	*val AdressatVorname	: 
	*val StraßeUndNummer	: 
	*val PLZUndWohnort		: 
	}
thing Rechnungsposition
	summary					: #Betrag #Währung : #Nachname #Vorname 
	{
	*val Nachname			: 
	*val Vorname				: 
	*val Mitgliedsnummer	: 
	*date AbrechnungVon	: 3 November 2017
	*date AbrechnungBis	: 3 November 2017
	*no Betrag				: 0
	*val Währung				: EUR
	}		
'! !

EFA subclass: #Kommunikation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

EFA subclass: #Stammdaten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Stammdaten subclass: #Boote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Boote class methodsFor: 'example' stamp: 'hk 11/8/2017 15:14'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		storeBoote ;
		booteContext) ui 
			title: #Boote; 
			open! !

!Boote methodsFor: 'functions' stamp: 'hk 10/17/2017 16:39'!
behaviors
 	^''! !

!Boote methodsFor: 'test data' stamp: 'hk 10/17/2017 16:33'!
boot
	^GbtSmartNode copy: 'Boot'! !

!Boote methodsFor: 'test data' stamp: 'hk 11/9/2017 18:16'!
boot01
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Wisch' ;	
		Bootstyp: #Einer;
		MannschaftAnzahlMax: 1;	
		steuermann: #ohne;
		Baujahr: 2001;
		yourself

! !

!Boote methodsFor: 'test data' stamp: 'hk 11/9/2017 18:16'!
boot02
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Alster' ;	
		Bootstyp: #Zweier;
		MannschaftAnzahlMax: 3;	
		steuermann: #mit;
		Baujahr: 1964;
		yourself

! !

!Boote methodsFor: 'test data' stamp: 'hk 11/9/2017 18:16'!
boot03
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Elbe' ;	
		Bootstyp: #Zweier;
		MannschaftAnzahlMax: 2;	
		steuermann: #ohne;
		Baujahr: 1980;
		yourself! !

!Boote methodsFor: 'contexts' stamp: 'hk 10/17/2017 16:39'!
booteContext 
	^GbtActiveContext definedAs: 'BooteContext' ! !

!Boote methodsFor: 'contexts' stamp: 'hk 11/27/2017 15:00'!
contexts
	^ '
plain BootContext {
	displayAs	: Boot
	icon	: rowingBoat
	uiSpec	: GbtItemUI
	}
primeList BooteContext of Boot{
	displayAs		: Boote
	icon			: rowingBoat
	uiSpec			: GbtListAndItemUI
	loadPolicy	: autoload
	listColumns	: (Bootsname Boot)(Bootstyp Typ)(Steuermann Steuermann)
	listPrefix	: Boot
	subcontext	: BootContext
	}
	'
! !

!Boote methodsFor: 'functions' stamp: 'hk 11/4/2017 21:41'!
directives
 	^''! !

!Boote methodsFor: 'test data' stamp: 'hk 10/17/2017 16:32'!
nextBizID
	^GbtServer default nextIdOfContextNoPolicy: #BooteContext! !

!Boote methodsFor: 'test data' stamp: 'hk 10/17/2017 16:32'!
storeBoote
	GbtServer default contextNoPolicyOf: #BooteContext prefix: #Boot.
	self boot01 storeSubtree.
	self boot02 storeSubtree.
	self boot03 storeSubtree! !

!Boote methodsFor: 'things' stamp: 'hk 12/1/2017 09:36'!
things
	^ '	
thing Boot
	summary	: #Bootsname
	bizIdPolicy	: BootNoPolicy
	{
	*val Bootstyp	: Einer | Zweier | Dreier | Vierer | Fünfer | Achter {ui: GbtChoiceWidget}
	*val Bootsname	: 
	*no MannschaftAnzahlMax	: 1
	val steuermann	: mit | ohne {ui: GbtChoiceWidget}
	val Baujahr	: 
	}
'! !

Stammdaten subclass: #FahrtenabzeichenStammdaten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Stammdaten subclass: #Personen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Personen class methodsFor: 'examples' stamp: 'hk 11/8/2017 15:13'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation ;
		storePersonen ;
		personenContext) ui 
			title: #Personen; 
			open! !

!Personen methodsFor: 'functions' stamp: 'hk 10/17/2017 22:17'!
behaviors
 	^''! !

!Personen methodsFor: 'contexts' stamp: 'hk 11/27/2017 15:00'!
contexts
	^ '	
plain PersonContext {
	displayAs		: Person
	icon			: rower
	uiSpec			: GbtItemUI
	}
primeList PersonenContext of Person{
	displayAs		: Personen
	icon			: rower
	uiSpec			: GbtListAndItemUI
	loadPolicy	: autoload
	listColumns	: (Nachname Name)(Vorname Vorname)
	listPrefix	: Sportler
	subcontext	: PersonContext
	}
 '! !

!Personen methodsFor: 'functions' stamp: 'hk 11/3/2017 18:49'!
directives
 	^''! !

!Personen methodsFor: 'test data' stamp: 'hk 10/18/2017 17:15'!
eMail
	^GbtSmartNode copy: 'EMail'! !

!Personen methodsFor: 'test data' stamp: 'hk 10/17/2017 17:41'!
nextBizID
	^GbtServer default nextIdOfContextNoPolicy: #PersonenContext
! !

!Personen methodsFor: 'test data' stamp: 'hk 10/17/2017 17:43'!
person
	^GbtSmartNode copy: 'Person'! !

!Personen methodsFor: 'test data' stamp: 'hk 11/9/2017 11:07'!
person01
	| tmp1 tmp2 tmp3 tmp4 tmp5 tmp7 tmp9 |
	tmp2 := self person.
	tmp1 := tmp2 mitglied.
	tmp1
		GebDatum: '08.06.1954';
		Mitgliedstatus: #aktiv;
		Beitragstatus: #Erwachsener;
		FamilienOberhaupt: #true;
		FamilienmitgliedNr: 1;
		MitgliedSeit: '01.01.1967';
		Familienname: #Schmidt;
		BeitragsSonderregelung: #false;
		Abrechnungsperiode: #jährlich;
		Beruf: 'Kaufmann';
		Familienname: 'Schmidt'.
	tmp7 := tmp1 KontoDaten.
	tmp7
		IBAN: 'DE1234567890';
		BIC: 'XYZABC'.
	tmp2
		Nachname: #Schmidt;
		Vorname: #Henning.
	tmp9 := tmp2 Kontaktdaten.
	tmp9
		StraßeUndNummer: 'Rethfelder Str 48';
		PLZUndWohnort: '25336 Elmshorn'.
	tmp3 := tmp2 Kommunikation.
	tmp4 := self telNo.
	tmp4 TelNr: '04121 48831'.
	tmp3 newEntry: tmp4 yourself with: 'Privat'.
	tmp5 := self eMail.
	tmp5 EMail: 'schmidt@gmail.com'.
	tmp3 newEntry: tmp5 yourself with: 'Privat'.
	^ tmp2! !

!Personen methodsFor: 'test data' stamp: 'hk 11/8/2017 16:59'!
person02
	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '10.07.1961' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 2.	
	m MitgliedSeit: '01.15.1993'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Buchhändlerin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	
	p Nachname: #Schmidt .
	p Vorname: #Christel.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	p Kommunikation 
		newEntry: ( self telNo TelNr: '04121 48832'; yourself)  with: 'Privat';
		newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen methodsFor: 'test data' stamp: 'hk 11/8/2017 16:58'!
person03
	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '03.10.1996' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Nichtverdiener14plus .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 3.	
	m MitgliedSeit: '01.01.2007'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Schülerin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	
	p Nachname: #Schmidt .
	p Vorname: #Imke.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	p Kommunikation 
		newEntry: ( self telNo TelNr: '04121 48833'; yourself)  with: 'Privat';
		newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen methodsFor: 'test data' stamp: 'hk 11/8/2017 16:58'!
person04
	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '10.10.1989' .	
	m Mitgliedstatus: #passiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 4.	
	m MitgliedSeit: '01.01.2000'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Sozialpädagogin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	
	p Nachname: #Schmidt .
	p Vorname: #Levke.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	p Kommunikation 
		newEntry: ( self telNo TelNr: '04121 48834'; yourself)  with: 'Privat';
		newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen methodsFor: 'contexts' stamp: 'hk 10/17/2017 17:47'!
personenContext 
	^GbtActiveContext definedAs: 'PersonenContext' ! !

!Personen methodsFor: 'test data' stamp: 'hk 10/17/2017 17:42'!
storePersonen
	| person |
	GbtServer default contextNoPolicyOf: #PersonenContext prefix: #Sportler.
	1 to: 10 do: [ :index | 
		person := self person01 bizId: self nextBizID.
		person Nachname: 'Schmidt' , index printString; storeSubtree ].
	1 to: 1 do: [ :index | 
		person := self person02 bizId: self nextBizID.
		person Nachname: 'Schmidt' , index printString; storeSubtree ].
	1 to: 1 do: [ :index | 
		person := self person03 bizId: self nextBizID.
		person Nachname: 'Schmidt' , index printString; storeSubtree ].
	1 to: 1 do: [ :index | 
		person := self person04 bizId: self nextBizID.
		person Nachname: 'Schmidt' , index printString; storeSubtree ]! !

!Personen methodsFor: 'test data' stamp: 'hk 10/18/2017 17:15'!
telNo
	^GbtSmartNode copy: 'TelNo'! !

!Personen methodsFor: 'things' stamp: 'hk 12/1/2017 09:38'!
things
	^ '	thing Person 
		summary 						: ''#Vorname #Nachname''
		bizIdPolicy 					: SportlerNoPolicy
		{ 
		*val Nachname 				:  
		*val Vorname 				:  
		*val Vorname2 				:  
		node Kontaktdaten 			: Kontaktdaten
		node Sportler 				: Sportlerdaten
		node mitglied 	 			: Mitglied
		}
	thing Mitglied
		summary 						: ''#Mitgliedstatus #Beitragstatus''
		bizIdPolicy 					: MitgliedNoPolicy
		{ 
		*date GebDatum 				: date(today)
		*val Mitgliedstatus 		: aktiv | passiv {ui: GbtChoiceWidget}
		*val Beitragstatus 		: Erwachsener | Nichtverdiener14+ | Kind14- {ui: GbtChoiceWidget}
		*bool FamilienOberhaupt 	: false | true {ui: GbtChoiceWidget}
		*no FamilienmitgliedNr 	: 1
		*date MitgliedSeit 		: date(today) 
		val Beruf						: 
		val Familienname 			:
		val FamilienNummer 		: bizId Oberhaupt 
		val Familienmitglieder 	: {ui: GbtChoiceWidget}
		val FahrtenabzeichenStatus : M18max | W18max | M18plus | W18plus {ui: GbtChoiceWidget}
		bool Schnuppermitglied 	: false | true {ui: GbtChoiceWidget}
		date Austrittserklärung 	: date(today) 
		date Austritt 				: ''if(#Austrittserklärung !!= nil , (if(#Schnuppermitglied, date+m(#MitgliedSeit,3) , silvester(today)''
		node KontoDaten 			: KontoDaten
		list Beitragsrechnung 	: Rechnung
		bool BeitragsSonderregelung : false | true {ui: GbtChoiceWidget}
		val Abrechnungsperiode 	: jährlich | halbjährlich | monatlich | sonstiges {ui: GbtChoiceWidget}
		}				
	thing Sportlerdaten
		summary 						: system template
		{  
		*val Fremdverein			:  
		*text Bemerkungen 			:  
		}
	thing TelNo
		summary 						: ''#TelNr''
		purposes 						: mobileprivat mobilarbeit Privat Arbeit Fax 
		{  
		*val TelNr					:  Telefonnummer
		}
	thing KontoDaten
		summary 						: #Kontoinhaber
		{  
		*val Kontoinhaber			: ''resolve (#Vorname #Nachname)''
		*val IBAN 					:
		*val BIC 						:
		}
	thing Kontaktdaten
		summary 						: EMail: #EMail Tel: #telNo
		{  
		val StraßeUndNummer		:  
		val PLZUndWohnort 			:
		list Kommunikation 		: TelNo EMail
		}
	thing EMail
		summary 						: #EMail 
		purposes 						: Privat Arbeit
		{  
		*val EMail					:  EMail
		}
'! !

EFA subclass: #Statistics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Statistics class methodsFor: 'example' stamp: 'hk 11/8/2017 15:13'!
exampleRun
	GbtServer clearStore; initialize. 
	(self new 
		ensureCompilation;
		statisticsContext ) ui 
			title: #Statistiken; 
			open! !

!Statistics methodsFor: 'functions' stamp: 'hk 11/24/2017 15:26'!
behaviors
	^'
behavior kmStatistik { 
	arg1 				:  contextThing 	% the default
	fahrten 			:  FahrtenBuchContext:list 
	constraint 		:  arg1:constraints
	selected			:  filter(fahrten constraint) 									
	kmStatistik 		:  arg1:resultList := nodeList(selected)
	}
behavior BooteStatistik {  
	statistik 		: kmStatisticBoote
	startListName 	: statistik:startList
	startListe 		: contextList (startListName)
	statistiken 		: directInto (DirBootsname statistik startListe)
	behavior 			: StatisticContext:kmStatistik
	resultListe 		: applyOnList (behavior statistiken)
	BooteStatistik 	: appendBL (StatisticsContext resultListe) 	
	}
behavior RudererStatistik {  
	statistik 		: kmStatisticRuderer
	startListName 	: statistik:startList
	startListe 		: contextList (startListName)
	statistiken 		: directInto ( DirRuderername statistik startListe)
	behavior 			: StatisticContext:kmStatistik
	resultListe 		: applyOnList (behavior statistiken)
	RudererStatistik : appendBL (StatisticsContext resultListe) 	
	}
	'! !

!Statistics methodsFor: 'contexts' stamp: 'hk 11/18/2017 17:39'!
contexts
^'
plain ErgebnisContext {
	displayAs	: Ergebnis
	icon	: statistics 
	uiSpec	: GbtItemUI 
	}
uList ErgebnisseContext  of Ergebnis {
	displayAs	: Ergebnisse
	icon	: statistics
	uiSpec	: GbtListAndItemUI
	listColumns	: Kilometer Abfahrt Ankunft Ziel Bootsname RudererName  
	subcontext	: ErgebnisContext
	elderSlot	: resultList
	}
plain StatisticContext {
	displayAs	: Statistik
	icon	: statistics
	uiSpec	: GbtItemWithTabsUI
	poolThings	: Ergebnis ErgebnisDir
	subcontexts	: ErgebnisseContext 
	menu	: kmStatistik 
	behaviors	: kmStatistik
	}
primeList StatisticsContext  of kmStatisticBoote kmStatisticRuderer kmStatistic {
	displayAs	: Statistiken
	icon	: statistics
	uiSpec	: GbtListAndItemUI
	poolThings	: DirBootsname DirRuderername
	loadPolicy	: simpleload
	listColumns	: km ruderer boot datum begin end  
	listPrefix	: Stat
	subcontext	: StatisticContext
	menu	: Run BooteStatistik RudererStatistik
	behaviors	: BooteStatistik RudererStatistik
	}
'! !

!Statistics methodsFor: 'functions' stamp: 'hk 11/20/2017 15:57'!
directives
	^'
directive DirBootsname {
	tag Bootsname 	: boot
	}
directive DirRuderername {
	tag Nachname 	: ruderer
	}
'! !

!Statistics methodsFor: 'contexts' stamp: 'hk 11/4/2017 18:47'!
statisticsContext 
	^GbtActiveContext definedAs: 'StatisticsContext' ! !

!Statistics methodsFor: 'things' stamp: 'hk 11/30/2017 16:47'!
things
	^'
thing Ergebnis
	summary	: km-Statistik
	{
	*val FahrtID	: 
	*date Datum	: date(today)
	*val Bootsname	: 
	*val RudererName	: 
	*val Kilometer	: 
	*date Abfahrt	: date(today)
	*date Ankunft	: date(today)
	*val Ziel	: 
	}
thing FahrtenConstraint
	{
	*date begin	: 1.1.2016
	*date end	: 12.31.2016
	*constraint gtBegin	: #Abfahrt > #begin
	*constraint ltEnd	: #Ankunft < #end
	*val boot	: 
	*constraint welches	: #Bootsname = #boot
	*val ruderer	: 
	*constraint wer	: #RudererName = #ruderer
	}
thing kmStatistic
	summary	: km-Statistik
	bizIdPolicy	: StatistikNoPolicy
	{
	*date datum	: date (today)
	*no km	: sumTag (Kilometer)
	*val startList	: BooteContext {ui: GbtChoiceWidget}
	*list resultList	: Ergebnis 
	*node constraints	: FahrtenConstraint
	}
thing BooteConstraint
	{
	*date begin	: 1.1.2016
	*date end	: 12.31.2016
	*constraint gtBegin	: #Abfahrt > #begin
	*constraint ltEnd	: #Ankunft < #end
	*val boot	: 
	*constraint welches	: #Bootsname = #boot
	}
thing kmStatisticBoote
	summary	: Boote-Statistik
	bizIdPolicy	: StatistikNoPolicy
	{
	*date datum	: date (today)
	*no km	: sumTag (Kilometer)
	*val startList	: BooteContext {ui: GbtChoiceWidget}
	*list resultList	: Ergebnis 
	*node constraints	: BooteConstraint
	}
thing RudererConstraint
	{
	*date begin	: 1.1.2016
	*date end	: 12.31.2016
	*constraint gtBegin	: #Abfahrt > #begin
	*constraint ltEnd	: #Ankunft < #end
	*val ruderer	: 
	*constraint wer	: #RudererName = #ruderer
	}
thing kmStatisticRuderer
	summary	: Ruderer-Statistik
	bizIdPolicy	: StatistikNoPolicy
	{
	*date datum	: date (today)
	*no km	: sumTag (Kilometer)
	*val startList	: PersonenContext {ui: GbtChoiceWidget}
	*list resultList	: Ergebnis 
	*node constraints	: RudererConstraint
	}
'! !
